;; Copyright (c) 2006-2007 Carlos Ungil

;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal in the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:

;; The above copyright notice and this permission notice shall be
;; included in all copies or substantial portions of the Software.

;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;; NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
;; LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
;; OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

(in-package :rclmathapi)

;; http://cran.r-project.org/doc/manuals/R-exts.html#Mathematical-functions

;; 6.7.2 Mathematical functions

(cffi:defcfun "gammafn" :double (x :double))
(cffi:defcfun "lgammafn" :double (x :double))
(cffi:defcfun "digamma" :double (x :double))
(cffi:defcfun "trigamma" :double (x :double))
(cffi:defcfun "tetragamma" :double (x :double))
(cffi:defcfun "pentagamma" :double (x :double))
(cffi:defcfun "psigamma" :double (x :double) (deriv :double))

;; The Gamma function, its natural logarithm and first four
;; derivatives and the n-th derivative of Psi, the digamma function.

;;; (cffi:defcfun "dpsifn" :void (x double) (n int) (kode int) (m int) (ans :pointer) (inz :pointer) (ierr :pointer))
;;; see https://svn.r-project.org/R/trunk/src/nmath/polygamma.c

(cffi:defcfun "beta" :double (a :double) (b :double)) 
(cffi:defcfun "lbeta" :double (a :double) (b :double))

;; The (complete) Beta function and its natural logarithm.

(cffi:defcfun "choose" :double (a :double) (b :double))
(cffi:defcfun "lchoose" :double (a :double) (b :double))

;; The number of combinations of k items chosen from from n and its
;; natural logarithm.  n and k are rounded to the nearest integer.

(cffi:defcfun "bessel_i" :double (x :double) (nu :double) (expo :double))
(cffi:defcfun "bessel_j" :double (x :double) (nu :double))
(cffi:defcfun "bessel_k" :double (x :double) (nu :double) (expo :double))
(cffi:defcfun "bessel_y" :double (x :double) (nu :double))

;; Bessel functions of types I, J, K and Y with index nu. For bessel_i
;; and bessel_k there is the option to return exp(-x)I(x;nu) or
;; exp(x)K(x;nu) if expo is 2.  (Use expo == 1 for unscaled values.)



